AcWing第129场周赛 - 5290. 重新分装 - 哈夫曼/贪心

解决这个问题前可以先把这三个问题想清楚
1、为什么可以使用哈夫曼树进行求解?

考虑逆操作
参考题解链接
2、为什么恰好是按照每堆所需要的数量分?针对某一堆,可以先分一部分吗?

首先这里按照每堆所正好含有的数量进行划分,是最优的

因为假想我们对于某一堆K,我们先只给它划分所需要的一部分重量

那么要想形成它所需要的质量,此时需要把某一堆O的质量分给它。

从而需要O本身的质量进行划分,这样的话肯定是没有直接整堆划分更优的
3、为什么优先对3堆进行合并而不是2堆?

这里选择优先合并3堆

因为假想一下有三堆,总和是sz。把它划分为三堆,花销即是sz。

但是如果合并两堆,这时需要先使用sz的花销划分为两堆a和b。

然后还需要min(a,b)来把两堆形成我们需要的三堆

AC代码:

cpp 复制代码
#include <math.h>
#include <stdio.h>
#include <algorithm>
#include <cstring>
#include <iostream>
#include <queue>
using namespace std;
const int N = 2e5 + 10;
#define de(x) cout << x << " ";
#define sf(x) scanf("%d", &x);
#define Pu puts("");
#define ll long long
ll n, m, ans;
priority_queue<ll, vector<ll>, greater<ll> > q;
int main() {
    cin >> n;
    // 首先这里按照每堆所正好含有的数量进行划分,是最优的
    // 因为假想我们对于某一堆K,我们先只给它划分所需要的一部分重量
    // 那么要想形成它所需要的质量,此时需要把某一堆O的质量分给它。
    // 从而需要O本身的质量进行划分,这样的话肯定是没有直接整堆划分更优的
    ll x;
    for (int i = 1; i <= n; i++) {
        scanf("%lld", &x);
        q.push(x);
    }
    m = 3;
    // 这里选择优先合并3堆
    // 因为假想一下有三堆,总和是sz。把它划分为三堆,花销即是sz。
    // 但是如果合并两堆,这时需要先使用sz的花销划分为两堆a和b。
    // 然后还需要min(a,b)来把两队形成我们需要的三堆
    while ((n - 1) % (m - 1)) {
        q.push(0ll);  // 特别巧妙
        n++;
    }
    ans = 0;
    ll t, sz;
    while (q.size() > 1) {
        sz = 0;
        for (int i = 1; i <= m; i++) {
            t = q.top();
            q.pop();
            sz += t;
        }
        q.push(sz);
        ans += sz;
    }
    de(ans);
    return 0;
}
相关推荐
怕浪猫1 小时前
RAG 面试 6 连问,从原理到优化全部覆盖
python·算法·面试
无线通信科研笔记2 小时前
IEEE TVT 2026 论文精读与完整复现|相位误差如何重塑近场 RIS 的幅相响应
论文阅读·人工智能·python·算法·论文笔记
mmmmath_33 小时前
二叉树の递归遍历
算法
All for pursuit.3 小时前
【位运算-1】338.比特位计数
数据结构·c++·算法·leetcode
小师兄吃牛肉4 小时前
C语言中的nullptr有必要吗
c语言·c++·算法
一只小小的芙厨5 小时前
【线性DP】
学习·算法·动态规划
奋发向前wcx6 小时前
CSP-J复赛模拟赛5 王晨旭补题 2026.10.5
算法
罗湖老棍子7 小时前
C Looooops(信息学奥赛一本通- P1640)
算法·数论·同余·裴蜀定理·扩展欧几里得
飘尘9 小时前
从"算子"到"AI Infra":大模型背后看不见的那群人在忙什么
人工智能·算法·面试
夏幻灵10 小时前
每日一题:LeetCode 3:无重复字符的最长子串——滑动窗口思路详解
算法·leetcode·职场和发展